/*--------------------------------------------------------------
	Peak control functions
		Written   by H.Goto, March 1996
		Rewritten by H.Goto, Sept. 1997
--------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1996-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef peakctl_h
#define peakctl_h

#include	"siplib.h"
#include	"sgplib.h"



/*------------------------------------------------------
	Peak buffer control
------------------------------------------------------*/

#define		PEAKSTAT_ACTIVE	0x8000


typedef struct {
	int	stat;
	int	x,y;
	int	value;
	int	p,q;
} peakpac;


class PEAKS {
    private:
	peakpac*	peaklist;
	int		maxpeaks;
	int		incalloc();
	int		out_count;
    public:
	int		counts;

	int		clear();
	int		trunc();
	int		setnewpeak(int x,int y,int value);
	int		setnewpeak(int x,int y,int value,int p,int q);
	int		deletepeak(int pkn);
	int		isactive(int pkn){ \
				return ( peaklist[pkn].stat & PEAKSTAT_ACTIVE ); }
	int		setfirst(){  out_count = 0; return 0; }
	int		seekto(int id);
	int		getnext(int *id,int *x,int *y,int *value);
	int		getnext(int *id,int *x,int *y,int *value,int *p,int *q);
	peakpac*	getpeak(int pkn);
	int		sortbyvalue();
			PEAKS();
			~PEAKS();
};




/*------------------------------------------------------
	Peak suppression
------------------------------------------------------*/

typedef struct {
	int	leftsup;
	int	rightsup;
	int	value;
} peakbuffer;


class PeakSuppress {
    private:
	int		len;
	peakbuffer	*peakbuf;
    public:
	int		allocpeakbuf(int len);
	void		clearpeakbuf();

	int		setpeaks(int x,peaklisti *pks,int peaks, \
					PEAKS *Pkp,int window);
			PeakSuppress();
	virtual		~PeakSuppress();
};




#endif	/* peakctl_h */
